#include <math.h>

#include "bitmap.h"

#define PI 3.141592653589793

void sampling(Bitmap<float> &image,float alpha){
  for (int i=0;i<image.getWidth();i++)
    for (int j=0;j<image.getHeight();j++){
      float x=2.*i/image.getWidth()-1,
            y=2.*j/image.getHeight()-1,
            r=x*x+y*y;
      image(i,j)=gray(127.5*cos(2*PI*r*alpha)+127.5);
    }
}

void copy(Bitmap<float> &source,Bitmap<float> &dest,int x,int y){
  for (int i=0;i<source.getWidth();i++)
    for (int j=0;j<source.getHeight();j++)
      dest(x+i,y+j)=source(i,j);
}

int main(){
  Bitmap<float> image(805,202),subimage(200);
  int beta,i;
  image.fill(image.red());
  for (beta=1,i=0;beta<=1000;beta*=10,i++){
    sampling(subimage,beta);
    copy(subimage,image,201*i+1,1);
  }
  SAVE_AND_SHOW(image,"prog1.bmp");
  return 0;
}

