#include <math.h>

#include "bitmap.h"

#define PI 3.141592653589793

void sample1(Bitmap<float> &image,float alpha){
  for (int i=0;i<image.getWidth();i++)
    for (int j=0;j<image.getHeight();j++){
      float x=2.*i/image.getWidth()-1,
            y=2.*j/image.getHeight()-1,
            r=x*x+y*y;
      image(i,j)=gray(127.5*cos(2*PI*r*alpha)+127.5);
    }
}

void sample2(Bitmap<float> &image,float alpha){
  for (int i=0;i<image.getWidth();i++)
    for (int j=0;j<image.getHeight();j++){
      float x=2.*i/image.getWidth()-1,
            y=2.*j/image.getHeight()-1,
            r=x*x+y*y;
      image(i,j)=gray(cos(2*PI*r*alpha)>0?0:255);
    }
}

void underSample(Bitmap<float> &source,Bitmap<float> &dest){
  dest.setSize(source.getWidth()/2,source.getHeight()/2);
  for (int i=0;i<dest.getWidth();i++)
    for (int j=0;j<dest.getHeight();j++){
      dest(i,j)=source(2*i,2*j)+source(2*i+1,2*j)+source(2*i,2*j+1)+source(2*i+1,2*j+1);
      dest(i,j)*=0.25;
    }
}

void copy(Bitmap<float> &source,Bitmap<float> &dest,int x,int y){
  for (int i=0;i<source.getWidth();i++)
    for (int j=0;j<source.getHeight();j++)
      dest(x+i,y+j)=source(i,j);
}

void multiUnderSample(Bitmap<float> &image,int n){
  Bitmap<float> temp;
  for (int i=0;i<n;i++){
    underSample(image,temp);
    image.setSize(temp.getWidth(),temp.getHeight());
    copy(temp,image,0,0);
  }
}

int main(){
  Bitmap<float> image1(400),image2(200),image(1006,403);
  float beta;
  int i;
  image.fill(image.red());
  for (beta=12,i=0;i<5;beta*=2,i++){
    sample1(image2,beta);
    copy(image2,image,201*i+1,202);

    sample1(image1,beta);
    underSample(image1,image2);
    copy(image2,image,201*i+1,1);
  }
  SAVE_AND_SHOW(image,"prog2a.bmp");
  for (beta=12,i=0;i<6;beta*=2,i++){
    sample2(image2,beta);
    copy(image2,image,201*i+1,202);

    sample2(image1,beta);
    underSample(image1,image2);
    copy(image2,image,201*i+1,1);
  }
  SAVE_AND_SHOW(image,"prog2b.bmp");
  image.setSize(1006,202);
  for (i=0;i<5;i++){
    image1.setSize(100*(2<<i));
    sample1(image1,400);
    multiUnderSample(image1,i);
    copy(image1,image,201*i+1,1);
  }
  SAVE_AND_SHOW(image,"prog2c.bmp");
  return 0;
}
